/* Программа для расчета катетов прямоугольного треугольника
 Гипотенуза = 1
 Угол в треугольнике задается пользователем
 Катеты рассчитываются с использованием sin & cos введенного угла
*/
//Угол 
float angle = 0.0;

void setup(){
  size(800,500,P3D);
}

void draw(){
  //Очищаем окно
  background(50,50,50);
  
  textSize(30);
  fill(#FC576A);
  //text("Откуда берутся Sinus & Cosinus",0,height/2);
  
  textSize(20);
  fill(#23EA21);
  text("Cos",width/4+50,height/2+25);
  fill(#EAE121);
  text("Sin",width/4-35,height/2-65);
  //text("Sin",250,300);
  
  //Перенос системы координат в центр окна
  //и поворот
  //Y /\
  //X >>>
  translate(width/4,height/2);
  rotateX(radians(180));
  
  
  //Точка центра
  strokeWeight(3);
  stroke(255,255,0);
  point(0,0);
  
  
  //Рассчитываем текущее положение точки на окружности
  //в зависимоти от угла
  float x = 100*cos(radians(angle));
  float y = 100*sin(radians(angle));

  
  //Окружность 1
  strokeWeight(1);
  noFill();
  ellipseMode(CENTER);
  //fill(50,50,50);
  stroke(#559CF7);
  ellipse(0,0,200,200);
  line(0,0,500,0);
  line(0,0,0,100);
  
  //Гипотенуза
  strokeWeight(4);
  stroke(255,0,0);
  line(0,0,x,y);
  
  //Катет А - COS
  stroke(0,255,0);
  line(0,0,x,0);
  //Катет B - SIN
  stroke(255,255,0);
  line(x,0,x,y);
  
  //Точка на периферии окружности
  strokeWeight(10);
  stroke(255,255,0);
  point(x,y);
  
  //Графики sin & cos 
  translate(100,0);
  float yyp=0, xxp=100;
  for(int a=0;a<360;a++){
    float xx = 100*cos(radians(a));
    float yy = 100*sin(radians(a));
    
    stroke(255,255,0);
    strokeWeight(2);
    line(a-1,yyp,a,yy);
    
    stroke(0,255,0);
    strokeWeight(2);
    line(a-1,xxp,a,xx);
    
    yyp = yy; xxp=xx;
  }
  
  //Скользящая точка по Графикам sin & cos 
  strokeWeight(10);
  stroke(255,255,0);
  point(angle,y);
  
  stroke(0,255,0);
  strokeWeight(10);
  point(angle,x);
   
}

void keyPressed(){
  if (keyCode==RIGHT){
    angle = angle + 5;
  }
  
  if (keyCode==LEFT){
    angle = angle - 5;
  }
}